import { FC, PropsWithChildren, ReactElement } from 'react';
import { IListProps as ICoreListProps } from '@reactionable/core';
export interface IListProps<Data> extends Omit<ICoreListProps<Data>, 'children'> {
    head: Array<ReactElement | string>;
    children: (data: Data) => ReactElement;
}
export declare type ListComponent<Data> = FC<IListProps<Data>>;
export declare function List<Data>({ head, children, ...props }: PropsWithChildren<IListProps<Data>>): JSX.Element;
