import { ReactElement, ElementType } from 'react';
import { FormControlProps } from 'react-bootstrap/FormControl';
import { FormCheckProps } from 'react-bootstrap/FormCheck';
import { ReplaceProps, BsPrefixProps } from 'react-bootstrap/helpers';
import { IFormFieldProps as ICoreFormFieldProps, IFormFieldPropsEnhanced as ICoreFormFieldPropsEnhanced, IFormFieldValue, IRenderFormField } from '@reactionable/core';
declare type IFieldElement = 'input' | 'select' | 'textarea' | 'checkbox' | 'radio';
export declare type IFormFieldProps<FieldElement extends IFieldElement, Value extends IFormFieldValue> = Omit<ICoreFormFieldProps<FieldElementProps<FieldElement>, Value>, 'children'> & {
    label?: ReactElement | string;
    children?: IRenderFormField<FieldElementProps<FieldElement>, Value> | ReactElement;
};
export declare type IFormFieldPropsEnhanced<FieldElement extends IFieldElement = 'input', Value extends IFormFieldValue = string> = ICoreFormFieldPropsEnhanced<FieldElementProps<FieldElement>, Value>;
declare type FieldElementProps<FieldElement extends IFieldElement> = FieldElement extends ElementType ? FieldFormElementProps<FieldElement> : FieldCheckElementProps;
declare type FieldFormElementProps<FieldElement extends ElementType> = ReplaceProps<FieldElement, BsPrefixProps<FieldElement> & FormControlProps>;
declare type FieldCheckElementProps = ReplaceProps<'input', BsPrefixProps<'input'> & FormCheckProps>;
export declare function FormField<FieldElement extends IFieldElement = 'input', Value extends IFormFieldValue = string>({ label, children, ...props }: IFormFieldProps<FieldElement, Value>): JSX.Element;
export {};
