"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var FormLabel_1 = tslib_1.__importDefault(require("react-bootstrap/FormLabel"));
var Feedback_1 = tslib_1.__importDefault(require("react-bootstrap/Feedback"));
var FormControl_1 = tslib_1.__importDefault(require("react-bootstrap/FormControl"));
var FormCheck_1 = tslib_1.__importDefault(require("react-bootstrap/FormCheck"));
var FormGroup_1 = tslib_1.__importDefault(require("react-bootstrap/FormGroup"));
var core_1 = require("@reactionable/core");
function isFormCheckProps(props) {
    return props.field.checked !== undefined;
}
function FormField(_a) {
    var label = _a.label, children = _a.children, props = tslib_1.__rest(_a, ["label", "children"]);
    var renderChildren = function (fieldProps) {
        var fieldContent = react_1.default.createElement(react_1.default.Fragment, null);
        if (fieldProps.error) {
            fieldContent = react_1.default.createElement(Feedback_1.default, { type: "invalid" }, fieldProps.error);
        }
        if ('function' === typeof children) {
            fieldContent = react_1.default.createElement(react_1.default.Fragment, null,
                children(fieldProps),
                fieldContent);
        }
        else {
            fieldContent = react_1.default.createElement(react_1.default.Fragment, null,
                isFormCheckProps(fieldProps)
                    ? react_1.default.createElement(FormCheck_1.default, tslib_1.__assign({}, tslib_1.__assign(tslib_1.__assign({}, fieldProps.field), { checked: !!fieldProps.field.value }), { children: children }))
                    : react_1.default.createElement(FormControl_1.default, tslib_1.__assign({}, fieldProps.field, { children: children })),
                fieldContent);
            if (fieldProps.field.type === 'hidden') {
                return fieldContent;
            }
        }
        return react_1.default.createElement(FormGroup_1.default, { controlId: fieldProps.field.name },
            label && react_1.default.createElement(FormLabel_1.default, null, label),
            fieldContent);
    };
    return react_1.default.createElement(core_1.FormField, tslib_1.__assign({}, tslib_1.__assign(tslib_1.__assign({}, props), { children: renderChildren })));
}
exports.FormField = FormField;
;
//# sourceMappingURL=FormField.js.map