"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@reactionable/core");
var react_1 = tslib_1.__importDefault(require("react"));
var react_i18next_1 = require("react-i18next");
var react_router_dom_1 = require("react-router-dom");
var Navbar_1 = tslib_1.__importDefault(require("react-bootstrap/Navbar"));
var Nav_1 = tslib_1.__importDefault(require("react-bootstrap/Nav"));
var NavDropdown_1 = tslib_1.__importDefault(require("react-bootstrap/NavDropdown"));
var Modal_1 = require("../../modal/Modal");
var NavItem_1 = require("../../nav/NavItem");
function isLinkProps(brand) {
    return brand.to !== undefined;
}
function Header(_a) {
    var _b;
    var brand = _a.brand, _c = _a.navItems, navItems = _c === void 0 ? [] : _c, navbarProps = tslib_1.__rest(_a, ["brand", "navItems"]);
    var t = react_i18next_1.useTranslation().t;
    var _d = core_1.useIdentityContext(), user = _d.user, logout = _d.logout, component = _d.component, identityProvider = _d.identityProvider;
    var _e = Modal_1.useModal({
        title: t('Sign In / Sign Up'),
        body: component,
    }), modal = _e.modal, openModal = _e.openModal, closeModal = _e.closeModal;
    react_1.default.useEffect(function () {
        if (user) {
            closeModal();
        }
    }, [user]);
    var userMenuItems = [];
    var identityModal = undefined;
    if (identityProvider) {
        if (user) {
            userMenuItems.push(react_1.default.createElement(NavDropdown_1.default, { key: "userNav", id: "userNav", title: user.displayName() },
                react_1.default.createElement(NavDropdown_1.default.Item, { as: react_router_dom_1.Link, to: "/account" }, t('My account')),
                react_1.default.createElement(NavDropdown_1.default.Divider, null),
                react_1.default.createElement(NavDropdown_1.default.Item, { as: react_router_dom_1.Link, to: "#", onClick: logout }, t('Log out'))));
        }
        else if (user === null) {
            var handleOnClick = function () { return openModal(); };
            userMenuItems.push(react_1.default.createElement(Nav_1.default.Link, { as: react_router_dom_1.Link, to: "#", key: "signup_signin", onClick: handleOnClick }, t('Sign In / Sign Up')));
            identityModal = modal;
        }
    }
    var brandContent = react_1.default.createElement(react_1.default.Fragment, null);
    if (brand) {
        brandContent = isLinkProps(brand) ? react_1.default.createElement(Navbar_1.default.Brand, tslib_1.__assign({ as: react_router_dom_1.Link }, brand)) : react_1.default.createElement(Navbar_1.default.Brand, { as: react_router_dom_1.Link, to: "/" }, brand);
    }
    return react_1.default.createElement(react_1.default.Fragment, null,
        identityModal,
        react_1.default.createElement(Navbar_1.default, tslib_1.__assign({ expand: "lg" }, navbarProps),
            brandContent,
            react_1.default.createElement(Navbar_1.default.Toggle, { "aria-controls": "main-navbar-nav" }),
            react_1.default.createElement(Navbar_1.default.Collapse, { id: "main-navbar-nav" },
                react_1.default.createElement(Nav_1.default, { className: "mr-auto" }, (_b = navItems) === null || _b === void 0 ? void 0 : _b.map(NavItem_1.navItemToComponent)),
                userMenuItems.length > 0 && react_1.default.createElement(Nav_1.default, null, userMenuItems))));
}
exports.Header = Header;
;
//# sourceMappingURL=Header.js.map