"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Modal_1 = tslib_1.__importDefault(require("react-bootstrap/Modal"));
var Button_1 = tslib_1.__importDefault(require("react-bootstrap/Button"));
var react_i18next_1 = require("react-i18next");
var core_1 = require("@reactionable/core");
var Form_1 = require("../form/Form");
var Modal_2 = require("./Modal");
;
function ModalForm(_a) {
    var submitButton = _a.submitButton, cancelButton = _a.cancelButton, closeModal = _a.closeModal, children = _a.children, formProps = tslib_1.__rest(_a, ["submitButton", "cancelButton", "closeModal", "children"]);
    var t = react_i18next_1.useTranslation().t;
    var renderFormChildren = function (formikProps) {
        var onCancel = function () {
            closeModal();
        };
        return react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Modal_1.default.Body, null, children(formikProps)),
            react_1.default.createElement(Modal_1.default.Footer, null,
                react_1.default.createElement(Button_1.default, { disabled: formikProps.isSubmitting, onClick: onCancel, variant: "secondary" }, cancelButton ? cancelButton : t('Cancel')),
                react_1.default.createElement(Button_1.default, { disabled: formikProps.isSubmitting, type: "submit", variant: "primary" }, submitButton ? submitButton : t('Save'))));
    };
    return react_1.default.createElement(Form_1.Form, tslib_1.__assign({}, formProps, { children: renderFormChildren }));
}
exports.ModalForm = ModalForm;
;
;
function useModalForm(props) {
    return core_1.useModalForm(tslib_1.__assign(tslib_1.__assign({}, props), { FormComponent: ModalForm, useModal: Modal_2.useModal }));
}
exports.useModalForm = useModalForm;
;
//# sourceMappingURL=ModalForm.js.map